VTK: vtkThreadedImageWriter Class Reference

| VTK 9.0.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
vtkThreadedImageWriter Class Reference

class used to compress/write images using threads to prevent locking while encoding data. More...

`#include <vtkThreadedImageWriter.h>`

Inheritance diagram for vtkThreadedImageWriter:
[legend]
Collaboration diagram for vtkThreadedImageWriter:
[legend]

## Public Types
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkThreadedImageWriter * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | Initialize ()
| Need to be called at least once before using the class. More...
void | EncodeAndWrite (vtkImageData *image, const char *fileName)
| Push an image into the threaded writer. More...
void | SetMaxThreads (vtkTypeUInt32)
| Define the number of worker thread to use. More...
virtual vtkTypeUInt32 | GetMaxThreads ()
void | Finalize ()
| This method will wait for any running thread to terminate. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
vtkCommand * | GetCommand (unsigned long tag)
void | RemoveObserver (vtkCommand *)
void | RemoveObservers (unsigned long event, vtkCommand *)
void | RemoveObservers (const char *event, vtkCommand *)
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
int | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
int | InvokeEvent (const char *event, void *callData)
int | InvokeEvent (unsigned long event)
int | InvokeEvent (const char *event)
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
void | PrintRevisions (ostream &)
| Legacy. More...

## Static Public Member Functions
static vtkThreadedImageWriter * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkThreadedImageWriter * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (int val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
static void | GlobalWarningDisplayOff ()
static int | GetGlobalWarningDisplay ()
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkThreadedImageWriter ()
| ~vtkThreadedImageWriter () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | CollectRevisions (ostream &)
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Additional Inherited Members
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

class used to compress/write images using threads to prevent locking while encoding data.

This writer allow to encode an image data based on its file extension: tif, tiff, bpm, png, jpg, jpeg, vti, Z, ppm, raw

Author
  Patricia Kroll Fasel @ LANL

Definition at line 34 of file vtkThreadedImageWriter.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkThreadedImageWriter::Superclass

Definition at line 38 of file vtkThreadedImageWriter.h.

## Constructor & Destructor Documentation

## ◆ vtkThreadedImageWriter()

vtkThreadedImageWriter::vtkThreadedImageWriter | ( |  | ) |
| protected

## ◆ ~vtkThreadedImageWriter()

vtkThreadedImageWriter::~vtkThreadedImageWriter | ( |  | ) |
| override protected

## Member Function Documentation

## ◆ New()

static vtkThreadedImageWriter* vtkThreadedImageWriter::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkThreadedImageWriter::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkThreadedImageWriter::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkObjectBase.

## ◆ SafeDownCast()

static vtkThreadedImageWriter* vtkThreadedImageWriter::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkThreadedImageWriter::NewInstanceInternal | ( |  | ) | const
| protected virtual

## ◆ NewInstance()

vtkThreadedImageWriter* vtkThreadedImageWriter::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkThreadedImageWriter::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| override virtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

## ◆ Initialize()

void vtkThreadedImageWriter::Initialize | ( |  | ) |

Need to be called at least once before using the class.

Then it should be called again after any change on the thread count or if Finalize() was called.

This method will wait for any running thread to terminate and start a new pool with the given number of threads.

## ◆ EncodeAndWrite()

void vtkThreadedImageWriter::EncodeAndWrite | ( | vtkImageData * | image,
|  | const char * | fileName
| ) |  |

Push an image into the threaded writer.

It is not safe to modify the image after this point. You may run into thread safety issues. Typically, the caller code will simply release reference to the data and stop using it.

## ◆ SetMaxThreads()

void vtkThreadedImageWriter::SetMaxThreads | ( | vtkTypeUInt32 |  | ) |

Define the number of worker thread to use.

Initialize() need to be called after any thread count change.

## ◆ GetMaxThreads()

virtual vtkTypeUInt32 vtkThreadedImageWriter::GetMaxThreads | ( |  | ) |
| virtual

## ◆ Finalize()

void vtkThreadedImageWriter::Finalize | ( |  | ) |

This method will wait for any running thread to terminate.

The documentation for this class was generated from the following file:

- IO/Asynchronous/vtkThreadedImageWriter.h